diff --git a/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderStatic.java b/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderStatic.java
index 6d23651e8..f19a55cdd 100644
--- a/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderStatic.java
+++ b/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderStatic.java
@@ -9,14 +9,16 @@ import net.minecraft.core.world.chunk.EmptyChunk;
 import net.minecraft.core.world.chunk.IChunkLoader;
 import net.minecraft.core.world.chunk.provider.IChunkProvider;
 import net.minecraft.core.world.generate.chunk.ChunkGenerator;
+import net.minecraft.core.world.pos.ChunkPos;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
 
 import java.io.IOException;
 import java.util.Arrays;
 
 public class ChunkProviderStatic
-    implements IChunkProvider
-{
+    implements IChunkProvider {
     public static final int CHUNK_RADIUS = 32; // Radius should *always* be a power of 2!
     public static final int CHUNK_MASK = CHUNK_RADIUS * 2 - 1;
 
@@ -33,205 +35,161 @@ public class ChunkProviderStatic
     private int curChunkY;
 
 
-    public ChunkProviderStatic(World world, IChunkLoader ichunkloader, ChunkGenerator chunkGenerator)
-    {
-        chunks = new Chunk[CHUNK_RADIUS * 2 * CHUNK_RADIUS * 2];
-        lastQueriedChunkXPos = Integer.MIN_VALUE;
-        lastQueriedChunkZPos = Integer.MIN_VALUE;
-        blankChunk = new EmptyChunk(world, 0, 0);
-        worldObj = world;
-        chunkLoader = ichunkloader;
+    public ChunkProviderStatic(World world, IChunkLoader ichunkloader, ChunkGenerator chunkGenerator) {
+        this.chunks = new Chunk[CHUNK_RADIUS * 2 * CHUNK_RADIUS * 2];
+        this.lastQueriedChunkXPos = Integer.MIN_VALUE;
+        this.lastQueriedChunkZPos = Integer.MIN_VALUE;
+        this.blankChunk = new EmptyChunk(world, 0, 0);
+        this.worldObj = world;
+        this.chunkLoader = ichunkloader;
         this.chunkGenerator = chunkGenerator;
 
     }
 
     @Override
-    public void setCurrentChunkOver(int chunkX, int chunkZ)
-    {
-        curChunkX = chunkX;
-        curChunkY = chunkZ;
+    public void setCurrentChunkOver(@NotNull ChunkPos chunkPos) {
+        this.curChunkX = chunkPos.x;
+        this.curChunkY = chunkPos.z;
     }
 
-    public boolean canChunkExist(int chunkX, int chunkZ)
-    {
+    public boolean canChunkExist(@NotNull ChunkPos chunkPos) {
         byte byte0 = CHUNK_RADIUS - 1;
-        return chunkX >= curChunkX - byte0 && chunkZ >= curChunkY - byte0 && chunkX <= curChunkX + byte0 && chunkZ <= curChunkY + byte0;
+        return chunkPos.x >= this.curChunkX - byte0 && chunkPos.z >= this.curChunkY - byte0 && chunkPos.x <= this.curChunkX + byte0 && chunkPos.z <= this.curChunkY + byte0;
     }
 
     @Override
-    public void regenerateChunk(int chunkX, int chunkZ)
-    {
-        int k = chunkX & CHUNK_MASK;
-        int l = chunkZ & CHUNK_MASK;
+    public void regenerateChunk(@NotNull ChunkPos chunkPos) {
+        int k = chunkPos.x & CHUNK_MASK;
+        int l = chunkPos.z & CHUNK_MASK;
         int i1 = k + l * CHUNK_RADIUS * 2;
         Chunk newChunk;
-        if (chunkGenerator != null)
-        {
-            newChunk = chunkGenerator.generate(chunkX, chunkZ);
+        if (this.chunkGenerator != null) {
+            newChunk = this.chunkGenerator.generate(chunkPos.x, chunkPos.z);
             newChunk.fixMissingBlocks();
-        }
-        else
-        {
+        } else {
             return;
         }
-        chunks[i1] = newChunk;
-        if(!chunks[i1].isTerrainPopulated && isChunkLoaded(chunkX + 1, chunkZ + 1) && isChunkLoaded(chunkX, chunkZ + 1) && isChunkLoaded(chunkX + 1, chunkZ))
-        {
-            populate(this, chunkX, chunkZ);
+        this.chunks[i1] = newChunk;
+        if (!this.chunks[i1].isTerrainPopulated && isChunkLoaded(chunkPos.x + 1, chunkPos.z + 1) && isChunkLoaded(chunkPos.x, chunkPos.z + 1) && isChunkLoaded(chunkPos.x + 1, chunkPos.z)) {
+            populate(this, chunkPos.x, chunkPos.z);
         }
-        if(isChunkLoaded(chunkX - 1, chunkZ) && !provideChunk(chunkX - 1, chunkZ).isTerrainPopulated && isChunkLoaded(chunkX - 1, chunkZ + 1) && isChunkLoaded(chunkX, chunkZ + 1) && isChunkLoaded(chunkX - 1, chunkZ))
-        {
-            populate(this, chunkX - 1, chunkZ);
+        if (isChunkLoaded(chunkPos.x - 1, chunkPos.z) && !provideChunk(chunkPos.x - 1, chunkPos.z).isTerrainPopulated && isChunkLoaded(chunkPos.x - 1, chunkPos.z + 1) && isChunkLoaded(chunkPos.x, chunkPos.z + 1) && isChunkLoaded(chunkPos.x - 1, chunkPos.z)) {
+            populate(this, chunkPos.x - 1, chunkPos.z);
         }
-        if(isChunkLoaded(chunkX, chunkZ - 1) && !provideChunk(chunkX, chunkZ - 1).isTerrainPopulated && isChunkLoaded(chunkX + 1, chunkZ - 1) && isChunkLoaded(chunkX, chunkZ - 1) && isChunkLoaded(chunkX + 1, chunkZ))
-        {
-            populate(this, chunkX, chunkZ - 1);
+        if (isChunkLoaded(chunkPos.x, chunkPos.z - 1) && !provideChunk(chunkPos.x, chunkPos.z - 1).isTerrainPopulated && isChunkLoaded(chunkPos.x + 1, chunkPos.z - 1) && isChunkLoaded(chunkPos.x, chunkPos.z - 1) && isChunkLoaded(chunkPos.x + 1, chunkPos.z)) {
+            populate(this, chunkPos.x, chunkPos.z - 1);
         }
-        if(isChunkLoaded(chunkX - 1, chunkZ - 1) && !provideChunk(chunkX - 1, chunkZ - 1).isTerrainPopulated && isChunkLoaded(chunkX - 1, chunkZ - 1) && isChunkLoaded(chunkX, chunkZ - 1) && isChunkLoaded(chunkX - 1, chunkZ))
-        {
-            populate(this, chunkX - 1, chunkZ - 1);
+        if (isChunkLoaded(chunkPos.x - 1, chunkPos.z - 1) && !provideChunk(chunkPos.x - 1, chunkPos.z - 1).isTerrainPopulated && isChunkLoaded(chunkPos.x - 1, chunkPos.z - 1) && isChunkLoaded(chunkPos.x, chunkPos.z - 1) && isChunkLoaded(chunkPos.x - 1, chunkPos.z)) {
+            populate(this, chunkPos.x - 1, chunkPos.z - 1);
         }
     }
 
     @Override
-    public boolean isChunkLoaded(int chunkX, int chunkZ)
-    {
-        if(!canChunkExist(chunkX, chunkZ))
-        {
+    public boolean isChunkLoaded(@NotNull ChunkPos chunkPos) {
+        if (!canChunkExist(chunkPos)) {
             return false;
         }
-        if(chunkX == lastQueriedChunkXPos && chunkZ == lastQueriedChunkZPos && lastQueriedChunk != null)
-        {
+        if (chunkPos.x == this.lastQueriedChunkXPos && chunkPos.z == this.lastQueriedChunkZPos && this.lastQueriedChunk != null) {
             return true;
-        } else
-        {
-            int k = chunkX & CHUNK_MASK;
-            int l = chunkZ & CHUNK_MASK;
+        } else {
+            int k = chunkPos.x & CHUNK_MASK;
+            int l = chunkPos.z & CHUNK_MASK;
             int chunkIndex = k + l * CHUNK_RADIUS * 2;
-            return chunks[chunkIndex] == blankChunk || (chunks[chunkIndex] != null && chunks[chunkIndex].isAtLocation(chunkX, chunkZ));
+            return this.chunks[chunkIndex] == this.blankChunk || (this.chunks[chunkIndex] != null && this.chunks[chunkIndex].isAtLocation(chunkPos.x, chunkPos.z));
         }
     }
 
     @Override
-    public Chunk prepareChunk(int chunkX, int chunkZ)
-    {
-        return provideChunk(chunkX, chunkZ);
+    public @NotNull Chunk prepareChunk(@NotNull ChunkPos chunkPos, boolean priority) {
+        return provideChunk(chunkPos.x, chunkPos.z);
     }
 
     @Override
-    public Chunk provideChunk(int chunkX, int chunkZ)
-    {
-        if(chunkX == lastQueriedChunkXPos && chunkZ == lastQueriedChunkZPos && lastQueriedChunk != null)
-        {
-            return lastQueriedChunk;
+    public @NotNull Chunk provideChunk(@NotNull ChunkPos chunkPos, boolean priority) {
+        if (chunkPos.x == this.lastQueriedChunkXPos && chunkPos.z == this.lastQueriedChunkZPos && this.lastQueriedChunk != null) {
+            return this.lastQueriedChunk;
         }
-        if(!worldObj.findingSpawnPoint && !canChunkExist(chunkX, chunkZ))
-        {
-            return blankChunk;
+        if (!this.worldObj.findingSpawnPoint && !canChunkExist(chunkPos)) {
+            return this.blankChunk;
         }
-        int k = chunkX & CHUNK_MASK;
-        int l = chunkZ & CHUNK_MASK;
+        int k = chunkPos.x & CHUNK_MASK;
+        int l = chunkPos.z & CHUNK_MASK;
         int i1 = k + l * CHUNK_RADIUS * 2;
-        if(!isChunkLoaded(chunkX, chunkZ))
-        {
-            if(chunks[i1] != null)
-            {
-                saveChunk(chunks[i1]);
-                chunks[i1].onUnload();
+        if (!isChunkLoaded(chunkPos.x, chunkPos.z)) {
+            if (this.chunks[i1] != null) {
+                saveChunk(this.chunks[i1]);
+                this.chunks[i1].onUnload();
             }
-            Chunk chunk = loadChunk(chunkX, chunkZ);
-            if(chunk == null)
-            {
-                if (chunkGenerator != null)
-                {
-                    chunk = chunkGenerator.generate(chunkX, chunkZ);
+            Chunk chunk = loadChunk(chunkPos);
+            if (chunk == null) {
+                if (this.chunkGenerator != null) {
+                    chunk = this.chunkGenerator.generate(chunkPos.x, chunkPos.z);
                     chunk.fixMissingBlocks();
-                }
-                else
-                {
-                    chunk = blankChunk;
+                } else {
+                    chunk = this.blankChunk;
                 }
             }
-            chunks[i1] = chunk;
-            if(chunks[i1] != null)
-            {
-                chunks[i1].onLoad();
+            this.chunks[i1] = chunk;
+            if (this.chunks[i1] != null) {
+                this.chunks[i1].checkForLightGaps();
+                this.chunks[i1].onLoad();
             }
-            if(!chunks[i1].isTerrainPopulated && isChunkLoaded(chunkX + 1, chunkZ + 1) && isChunkLoaded(chunkX, chunkZ + 1) && isChunkLoaded(chunkX + 1, chunkZ))
-            {
-                populate(this, chunkX, chunkZ);
+            if (!this.chunks[i1].isTerrainPopulated && isChunkLoaded(chunkPos.x + 1, chunkPos.z + 1) && isChunkLoaded(chunkPos.x, chunkPos.z + 1) && isChunkLoaded(chunkPos.x + 1, chunkPos.z)) {
+                populate(this, chunkPos.x, chunkPos.z);
             }
-            if(isChunkLoaded(chunkX - 1, chunkZ) && !provideChunk(chunkX - 1, chunkZ).isTerrainPopulated && isChunkLoaded(chunkX - 1, chunkZ + 1) && isChunkLoaded(chunkX, chunkZ + 1) && isChunkLoaded(chunkX - 1, chunkZ))
-            {
-                populate(this, chunkX - 1, chunkZ);
+            if (isChunkLoaded(chunkPos.x - 1, chunkPos.z) && !provideChunk(chunkPos.x - 1, chunkPos.z).isTerrainPopulated && isChunkLoaded(chunkPos.x - 1, chunkPos.z + 1) && isChunkLoaded(chunkPos.x, chunkPos.z + 1) && isChunkLoaded(chunkPos.x - 1, chunkPos.z)) {
+                populate(this, chunkPos.x - 1, chunkPos.z);
             }
-            if(isChunkLoaded(chunkX, chunkZ - 1) && !provideChunk(chunkX, chunkZ - 1).isTerrainPopulated && isChunkLoaded(chunkX + 1, chunkZ - 1) && isChunkLoaded(chunkX, chunkZ - 1) && isChunkLoaded(chunkX + 1, chunkZ))
-            {
-                populate(this, chunkX, chunkZ - 1);
+            if (isChunkLoaded(chunkPos.x, chunkPos.z - 1) && !provideChunk(chunkPos.x, chunkPos.z - 1).isTerrainPopulated && isChunkLoaded(chunkPos.x + 1, chunkPos.z - 1) && isChunkLoaded(chunkPos.x, chunkPos.z - 1) && isChunkLoaded(chunkPos.x + 1, chunkPos.z)) {
+                populate(this, chunkPos.x, chunkPos.z - 1);
             }
-            if(isChunkLoaded(chunkX - 1, chunkZ - 1) && !provideChunk(chunkX - 1, chunkZ - 1).isTerrainPopulated && isChunkLoaded(chunkX - 1, chunkZ - 1) && isChunkLoaded(chunkX, chunkZ - 1) && isChunkLoaded(chunkX - 1, chunkZ))
-            {
-                populate(this, chunkX - 1, chunkZ - 1);
+            if (isChunkLoaded(chunkPos.x - 1, chunkPos.z - 1) && !provideChunk(chunkPos.x - 1, chunkPos.z - 1).isTerrainPopulated && isChunkLoaded(chunkPos.x - 1, chunkPos.z - 1) && isChunkLoaded(chunkPos.x, chunkPos.z - 1) && isChunkLoaded(chunkPos.x - 1, chunkPos.z)) {
+                populate(this, chunkPos.x - 1, chunkPos.z - 1);
             }
-            if (worldObj.getCurrentWeather() != null)
-            {
-                worldObj.getCurrentWeather().doChunkLoadEffect(worldObj, chunk);
+            if (this.worldObj.getCurrentWeather() != null) {
+                this.worldObj.getCurrentWeather().doChunkLoadEffect(this.worldObj, chunk);
             }
         }
-        lastQueriedChunkXPos = chunkX;
-        lastQueriedChunkZPos = chunkZ;
-        lastQueriedChunk = chunks[i1];
-        return chunks[i1];
+        this.lastQueriedChunkXPos = chunkPos.x;
+        this.lastQueriedChunkZPos = chunkPos.z;
+        this.lastQueriedChunk = this.chunks[i1];
+        return this.chunks[i1];
     }
 
-    private Chunk loadChunk(int chunkX, int chunkZ)
-    {
-        if(chunkLoader == null)
-        {
-            return blankChunk;
+    private Chunk loadChunk(@NotNull ChunkPos chunkPos) {
+        if (this.chunkLoader == null) {
+            return this.blankChunk;
         }
-        try
-        {
-            Chunk chunk = chunkLoader.loadChunk(worldObj, chunkX, chunkZ);
-            if(chunk != null)
-            {
-                chunk.lastSaveTime = worldObj.getWorldTime();
+        try {
+            Chunk chunk = this.chunkLoader.loadChunk(this.worldObj, chunkPos.x, chunkPos.z);
+            if (chunk != null) {
+                chunk.lastSaveTime = this.worldObj.getWorldTime();
             }
             return chunk;
+        } catch (Exception exception) {
+            LOGGER.error("Error loading chunk at X:{}, Z:{}", chunkPos.x, chunkPos.z, exception);
         }
-        catch(Exception exception)
-        {
-            LOGGER.error("Error loading chunk at X:{}, Z:{}", chunkX, chunkZ, exception);
-        }
-        return blankChunk;
+        return this.blankChunk;
     }
 
-    private void saveChunk(Chunk chunk)
-    {
-        if(chunkLoader == null)
-        {
+    private void saveChunk(Chunk chunk) {
+        if (this.chunkLoader == null) {
             return;
         }
-        try
-        {
-            chunk.lastSaveTime = worldObj.getWorldTime();
-            chunkLoader.saveChunk(worldObj, chunk);
-        }
-        catch(IOException e)
-        {
+        try {
+            chunk.lastSaveTime = this.worldObj.getWorldTime();
+            this.chunkLoader.saveChunk(this.worldObj, chunk);
+        } catch (IOException e) {
             LOGGER.error("Error saving chunk at X:{}, Z:{}", chunk.pos.x, chunk.pos.x, e);
         }
     }
 
     @Override
-    public void populate(IChunkProvider chunkProvider, int chunkX, int chunkZ)
-    {
-        Chunk chunk = provideChunk(chunkX, chunkZ);
-        if(!chunk.isTerrainPopulated)
-        {
+    public void populate(@NotNull ChunkPos chunkPos) {
+        Chunk chunk = provideChunk(chunkPos, true);
+        if (!chunk.isTerrainPopulated) {
             chunk.isTerrainPopulated = true;
-            if (this.chunkGenerator != null)
-            {
+            if (this.chunkGenerator != null) {
                 this.chunkGenerator.decorate(chunk);
                 chunk.setChunkModified();
             }
@@ -239,41 +197,32 @@ public class ChunkProviderStatic
     }
 
     @Override
-    public boolean saveChunks(boolean saveImmediately, ProgressListener progressUpdate)
-    {
+    public boolean saveChunks(boolean saveImmediately, @Nullable ProgressListener progressListener) {
         int i = 0;
         int j = 0;
-        if(progressUpdate != null)
-        {
-            for(int k = 0; k < chunks.length; k++)
-            {
-                if(chunks[k] != null && chunks[k].needsSaving(saveImmediately))
-                {
+        if (progressListener != null) {
+            for (int k = 0; k < this.chunks.length; k++) {
+                if (this.chunks[k] != null && this.chunks[k].needsSaving(saveImmediately)) {
                     j++;
                 }
             }
 
         }
         int l = 0;
-        for(int i1 = 0; i1 < chunks.length; i1++)
-        {
-            if(chunks[i1] == null)
-            {
+        for (int i1 = 0; i1 < this.chunks.length; i1++) {
+            if (this.chunks[i1] == null) {
                 continue;
             }
-            if(!chunks[i1].needsSaving(saveImmediately))
-            {
+            if (!this.chunks[i1].needsSaving(saveImmediately)) {
                 continue;
             }
-            saveChunk(chunks[i1]);
-            chunks[i1].isModified = false;
-            if(++i == 2 && !saveImmediately)
-            {
+            saveChunk(this.chunks[i1]);
+            this.chunks[i1].isModified = false;
+            if (++i == 2 && !saveImmediately) {
                 return false;
             }
-            if(progressUpdate != null && ++l % 10 == 0)
-            {
-                progressUpdate.progressStagePercentage((l * 100) / j);
+            if (progressListener != null && ++l % 10 == 0) {
+                progressListener.progressStagePercentage((l * 100) / j);
             }
         }
 
@@ -281,35 +230,31 @@ public class ChunkProviderStatic
     }
 
     @Override
-    public boolean tick()
-    {
+    public boolean tick() {
         return false;
     }
 
     @Override
-    public void unloadAllChunks()
-    {
-        for (Chunk chunk : chunks) {
+    public void unloadAllChunks() {
+        for (Chunk chunk : this.chunks) {
             if (chunk != null) chunk.onUnload();
         }
-        Arrays.fill(chunks, null);
-        chunkGenerator = null;
-    	System.gc();
+        Arrays.fill(this.chunks, null);
+        this.chunkGenerator = null;
+        System.gc();
     }
 
     @Override
-    public boolean canSave()
-    {
+    public boolean canSave() {
         return true;
     }
 
     @Override
-    public String getInfoString()
-    {
-        return "ChunkCache: " + chunks.length;
+    public @NotNull String getInfoString() {
+        return "ChunkCache: " + this.chunks.length;
     }
 
     public IChunkLoader getChunkLoader() {
-        return chunkLoader;
+        return this.chunkLoader;
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderThreadedClient.java b/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderThreadedClient.java
new file mode 100644
index 000000000..a3466059c
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderThreadedClient.java
@@ -0,0 +1,39 @@
+package net.minecraft.client.world.chunk.provider;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.chunk.IChunkLoader;
+import net.minecraft.core.world.chunk.provider.ChunkProviderThreaded;
+import net.minecraft.core.world.generate.chunk.ChunkGenerator;
+import net.minecraft.core.world.pos.ChunkPos;
+import org.jetbrains.annotations.NotNull;
+
+public class ChunkProviderThreadedClient extends ChunkProviderThreaded {
+    public ChunkProviderThreadedClient(@NotNull World world, @NotNull IChunkLoader chunkLoader, @NotNull ChunkGenerator chunkGenerator) {
+        super(world, chunkLoader, chunkGenerator);
+    }
+
+    @Override
+    protected boolean isChunkValid(@NotNull ChunkPos chunkPos) {
+        Minecraft mc = Minecraft.getMinecraft();
+        int rd = this.world.renderDistance() + 1;
+        if (this.chunkOver != null) {
+            int dx = this.chunkOver.x - chunkPos.x;
+            int dz = this.chunkOver.z - chunkPos.z;
+            if (dx <= 2 && dx >= -2 && dz <= 2 && dz >= -2) {
+                return true;
+            }
+        }
+
+        Player player = mc.thePlayer;
+        if (player != null) {
+            int pCX = ((int) player.x >> 4);
+            int pCZ = ((int) player.z >> 4);
+            int dx = pCX - chunkPos.x;
+            int dz = pCZ - chunkPos.z;
+            return dx <= rd && dx >= -rd && dz <= rd && dz >= -rd;
+        }
+        return false;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderViewer.java b/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderViewer.java
index 1819a8502..287109632 100644
--- a/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderViewer.java
+++ b/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderViewer.java
@@ -6,47 +6,52 @@ import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.chunk.DisplayChunk;
 import net.minecraft.core.world.chunk.EmptyChunk;
 import net.minecraft.core.world.chunk.provider.IChunkProvider;
+import net.minecraft.core.world.pos.ChunkPos;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class ChunkProviderViewer implements IChunkProvider {
-    public final Chunk blankChunk;
-    public final Chunk displayChunk;
-    public ChunkProviderViewer(World world){
-        blankChunk = new EmptyChunk(world, 0, 0);
-        displayChunk = new DisplayChunk(world, 0, 0);
+    public final @NotNull Chunk blankChunk;
+    public final @NotNull Chunk displayChunk;
+
+    public ChunkProviderViewer(World world) {
+        this.blankChunk = new EmptyChunk(world, 0, 0);
+        this.displayChunk = new DisplayChunk(world, 0, 0);
     }
+
     @Override
-    public boolean isChunkLoaded(int chunkX, int chunkZ) {
+    public boolean isChunkLoaded(@NotNull ChunkPos chunkPos) {
         return true;
     }
 
     @Override
-    public Chunk provideChunk(int chunkX, int chunkZ) {
-        if (chunkX == 0 && chunkZ == 0){
-            return displayChunk;
+    public @NotNull Chunk provideChunk(@NotNull ChunkPos chunkPos, boolean priority) {
+        if (chunkPos.x == 0 && chunkPos.z == 0) {
+            return this.displayChunk;
         }
-        return blankChunk;
+        return this.blankChunk;
     }
 
     @Override
-    public Chunk prepareChunk(int chunkX, int chunkZ) {
-        if (chunkX == 0 && chunkZ == 0){
-            return displayChunk;
+    public @NotNull Chunk prepareChunk(@NotNull ChunkPos chunkPos, boolean priority) {
+        if (chunkPos.x == 0 && chunkPos.z == 0) {
+            return this.displayChunk;
         }
-        return blankChunk;
+        return this.blankChunk;
     }
 
     @Override
-    public void regenerateChunk(int chunkX, int chunkZ) {
+    public void regenerateChunk(@NotNull ChunkPos chunkPos) {
 
     }
 
     @Override
-    public void populate(IChunkProvider chunkProvider, int chunkX, int chunkZ) {
+    public void populate(@NotNull ChunkPos chunkPos) {
 
     }
 
     @Override
-    public boolean saveChunks(boolean saveImmediately, ProgressListener progressUpdate) {
+    public boolean saveChunks(boolean saveImmediately, @Nullable ProgressListener progressListener) {
         return false;
     }
 
@@ -61,8 +66,8 @@ public class ChunkProviderViewer implements IChunkProvider {
     }
 
     @Override
-    public String getInfoString() {
-        return null;
+    public @NotNull String getInfoString() {
+        return "";
     }
 
     @Override
@@ -71,7 +76,7 @@ public class ChunkProviderViewer implements IChunkProvider {
     }
 
     @Override
-    public void setCurrentChunkOver(int chunkX, int chunkZ) {
+    public void setCurrentChunkOver(@NotNull ChunkPos chunkPos) {
 
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/world/chunk/provider/SelectedProvider.java b/game/client/src/main/java/net/minecraft/client/world/chunk/provider/SelectedProvider.java
new file mode 100644
index 000000000..5e05139e2
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/world/chunk/provider/SelectedProvider.java
@@ -0,0 +1,8 @@
+package net.minecraft.client.world.chunk.provider;
+
+public enum SelectedProvider {
+    STATIC,
+    DYNAMIC,
+    THREADED;
+
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/SpawnerMobs.java b/game/core/src/main/java/net/minecraft/core/world/SpawnerMobs.java
index 7dfac1349..606fb71d5 100644
--- a/game/core/src/main/java/net/minecraft/core/world/SpawnerMobs.java
+++ b/game/core/src/main/java/net/minecraft/core/world/SpawnerMobs.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.world;
 
 import com.mojang.logging.LogUtils;
+import it.unimi.dsi.fastutil.objects.ObjectOpenHashSet;
 import net.minecraft.core.block.BlockLogicBed;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.data.gamerule.GameRules;
@@ -33,7 +34,7 @@ import java.util.Set;
 public final class SpawnerMobs
 {
     private static final Logger LOGGER = LogUtils.getLogger();
-    private static final Set<ChunkCoordinate> ELIGIBLE_CHUNKS_FOR_SPAWNING = new HashSet<>();
+    private static final Set<ChunkCoordinate> ELIGIBLE_CHUNKS_FOR_SPAWNING = new ObjectOpenHashSet<>();
     private static final Class<? extends Mob>[] NIGHT_SPAWN_ENTITIES;
 
     static
diff --git a/game/core/src/main/java/net/minecraft/core/world/World.java b/game/core/src/main/java/net/minecraft/core/world/World.java
index 240f39051..ffe61ad2c 100644
--- a/game/core/src/main/java/net/minecraft/core/world/World.java
+++ b/game/core/src/main/java/net/minecraft/core/world/World.java
@@ -6,6 +6,8 @@ import java.util.*;
 
 import com.mojang.logging.LogUtils;
 
+import it.unimi.dsi.fastutil.objects.ObjectArrayList;
+import it.unimi.dsi.fastutil.objects.ObjectOpenHashSet;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.support.ISupport;
 import net.minecraft.core.block.support.PartialSupport;
@@ -84,17 +86,17 @@ public class World implements MutableWorldSource {
     public static final int MAX_SCHEDULED_TICKS_IN_TICK = 1000;
     public static final int ANIMATION_TICKS_PER_TICK = 1000;
 
-    public final @NotNull List<@NotNull Entity> entities = new ArrayList<>();
-    private final @NotNull List<@NotNull Entity> entitiesToRemove = new ArrayList<>();
+    public final @NotNull List<@NotNull Entity> entities = new ObjectArrayList<>();
+    private final @NotNull List<@NotNull Entity> entitiesToRemove = new ObjectArrayList<>();
     private final @NotNull TreeSet<@NotNull NextTickListEntry> tickNextTickList = new TreeSet<>();
-    public final @NotNull List<@NotNull TileEntity> tileEntityList = new ArrayList<>();
-    public final @NotNull List<@NotNull Player> players = new ArrayList<>();
-    public final @NotNull List<@NotNull Entity> weatherEffects = new ArrayList<>();
+    public final @NotNull List<@NotNull TileEntity> tileEntityList = new ObjectArrayList<>();
+    public final @NotNull List<@NotNull Player> players = new ObjectArrayList<>();
+    public final @NotNull List<@NotNull Entity> weatherEffects = new ObjectArrayList<>();
     public final @NotNull ArrayList<@NotNull AABB> collidingBoundingBoxes = new ArrayList<>();
-    public final @NotNull List<@NotNull LevelListener> listeners = new ArrayList<>();
-    private final @NotNull Set<@NotNull ChunkCoordinate> positionsToUpdate = new HashSet<>();
-    private final @NotNull List<@NotNull Entity> entityBuffer = new ArrayList<>();
-    private final @NotNull Set<@NotNull NextTickListEntry> immediatelyUpdatedPositions = new HashSet<>();
+    public final @NotNull List<@NotNull LevelListener> listeners = new ObjectArrayList<>();
+    private final @NotNull Set<@NotNull ChunkCoordinate> positionsToUpdate = new ObjectOpenHashSet<>();
+    private final @NotNull List<@NotNull Entity> entityBuffer = new ObjectArrayList<>();
+    private final @NotNull Set<@NotNull NextTickListEntry> immediatelyUpdatedPositions = new ObjectOpenHashSet<>();
 
     public boolean scheduledUpdatesAreImmediate = false;
     public int skyDarken = 0;
@@ -126,11 +128,8 @@ public class World implements MutableWorldSource {
     public int dayCountLastTick;
     
     public BiomeProvider biomeProvider;
-
     public AuroraProvider auroraProvider;
-
     public SeasonManager seasonManager;
-
     public WeatherManager weatherManager;
 
     private CommandManager commandManager;
@@ -409,17 +408,14 @@ public class World implements MutableWorldSource {
         savedDataStorage.save();
     }
 
-    public boolean pauseScreenSave(int i)
-    {
-        if(!chunkProvider.canSave())
-        {
+    public boolean pauseScreenSave(int i) {
+        if(!this.chunkProvider.canSave()) {
             return true;
         }
-        if(i == 0)
-        {
+        if(i == 0) {
             saveWorldData();
         }
-        return chunkProvider.saveChunks(false, null);
+        return this.chunkProvider.saveChunks(false, null);
     }
 
     public @Nullable Weather getCurrentWeather()
@@ -634,7 +630,7 @@ public class World implements MutableWorldSource {
     }
 
     public boolean isChunkLoaded(final @NotNull ChunkPos chunkPos) {
-        return this.chunkProvider.isChunkLoaded(chunkPos.x, chunkPos.z);
+        return this.chunkProvider.isChunkLoaded(chunkPos);
     }
 
     @Deprecated
@@ -652,7 +648,11 @@ public class World implements MutableWorldSource {
     }
 
     public @NotNull Chunk getChunk(final @NotNull ChunkPos chunkPos) {
-        return this.chunkProvider.provideChunk(chunkPos.x, chunkPos.z);
+        return this.chunkProvider.provideChunk(chunkPos, true);
+    }
+
+    public @NotNull Chunk getChunk(final @NotNull ChunkPos chunkPos, boolean priority) {
+        return this.chunkProvider.provideChunk(chunkPos, priority);
     }
 
     @Deprecated
@@ -2149,6 +2149,10 @@ public class World implements MutableWorldSource {
         }
     }
 
+    public void close() {
+        this.chunkProvider.close();
+    }
+
     public void saveWorldIndirectly(ProgressListener iprogressupdate)
     {
         saveWorld(true, iprogressupdate, true);
@@ -2175,6 +2179,10 @@ public class World implements MutableWorldSource {
         );
     }
 
+    public LightingEngine getLightingEngine() {
+        return lightingEngine;
+    }
+
     @Deprecated
     public final void scheduleLightingUpdate(final @NotNull LightLayer lightLayer, final int minX, final int minY, final int minZ, final int maxX, final int maxY, final int maxZ) {
         this.scheduleLightingUpdate(lightLayer, new TilePos(minX, minY, minZ), new TilePos(maxX, maxY, maxZ));
@@ -2574,7 +2582,8 @@ public class World implements MutableWorldSource {
         final @NotNull TilePos cacheMin = entityPos.sub(cacheRadius, cacheRadius, cacheRadius);
         final @NotNull TilePos cacheMax = entityPos.add(cacheRadius, cacheRadius, cacheRadius);
 
-        final @NotNull ChunkCache cache = new ChunkCache(this, cacheMin.x, cacheMin.y, cacheMin.z, cacheMax.x, cacheMax.y, cacheMax.z);
+        final @NotNull ChunkCache cache = new ChunkCache(this, cacheMin, cacheMax, false);
+        if (!cache.allLoaded()) return null;
         return new PathFinder(cache).findPath(entity, tilePos.x, tilePos.y, tilePos.z, distance);
     }
 
@@ -3122,4 +3131,8 @@ public class World implements MutableWorldSource {
             player.sendMessage(message);
         }
     }
+
+    public int renderDistance() {
+        return 12;
+    }
 }
